commit 07b0cdf9b2c3f25ea731704ec04faaa183a14b2f
Author: freddy77 <freddy77>
Date:   Wed Aug 4 06:55:45 2010 +0000

    fix problem for pyodbc and money

diff --git a/ChangeLog b/ChangeLog
index ac2f660..0dbd95f 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,9 @@
+Wed Aug  4 08:55:25 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/odbc.c src/odbc/odbc_util.c:
+	* src/odbc/unittests/describecol.c:
+	* src/odbc/unittests/describecol.in:
+	- fix problem for pyodbc and money
+
 Sat Jul 31 13:31:08 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/dblib/bcp.c: fix bcp_bind with vartype == 0
 
@@ -2802,4 +2808,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.3105 2010/07/31 11:31:15 freddy77 Exp $
+$Id: ChangeLog,v 1.3106 2010/08/04 06:55:45 freddy77 Exp $
diff --git a/src/odbc/odbc.c b/src/odbc/odbc.c
index a9db1be..0359783 100644
--- a/src/odbc/odbc.c
+++ b/src/odbc/odbc.c
@@ -61,7 +61,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc.c,v 1.549 2010/07/30 09:09:36 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc.c,v 1.550 2010/08/04 06:55:45 freddy77 Exp $");
 
 static SQLRETURN _SQLAllocConnect(SQLHENV henv, SQLHDBC FAR * phdbc);
 static SQLRETURN _SQLAllocEnv(SQLHENV FAR * phenv, SQLINTEGER odbc_version);
@@ -3010,10 +3010,7 @@ odbc_populate_ird(TDS_STMT * stmt)
 		if (!tds_dstr_copyn(&drec->sql_desc_label, col->column_name, col->column_namelen))
 			return SQL_ERROR;
 
-		/* TODO other types for date ?? SQL_TYPE_DATE, SQL_TYPE_TIME */
-		if (drec->sql_desc_concise_type == SQL_TIMESTAMP || drec->sql_desc_concise_type == SQL_TYPE_TIMESTAMP)
-			drec->sql_desc_length = sizeof("2000-01-01 12:00:00.0000")-1;
-		else switch (drec->sql_desc_concise_type) {
+		switch (drec->sql_desc_concise_type) {
 		case SQL_WCHAR:
 		case SQL_WVARCHAR:
 		case SQL_WLONGVARCHAR:
@@ -3085,7 +3082,7 @@ odbc_populate_ird(TDS_STMT * stmt)
 		drec->sql_desc_unnamed = tds_dstr_isempty(&drec->sql_desc_name) ? SQL_UNNAMED : SQL_NAMED;
 		/* TODO use is_nullable_type ?? */
 		drec->sql_desc_nullable = col->column_nullable ? SQL_TRUE : SQL_FALSE;
-		if (drec->sql_desc_concise_type == SQL_NUMERIC || drec->sql_desc_concise_type == SQL_DECIMAL) {
+		if (drec->sql_desc_concise_type == SQL_NUMERIC) {
 			drec->sql_desc_num_prec_radix = 10;
 			drec->sql_desc_octet_length = col->column_prec + 2;
 		} else {
@@ -3104,10 +3101,26 @@ odbc_populate_ird(TDS_STMT * stmt)
 		}
 
 		drec->sql_desc_octet_length_ptr = NULL;
-		drec->sql_desc_precision = type == SYBDATETIME ? 3 : col->column_prec;
+		switch (type) {
+		case SYBDATETIME:
+			drec->sql_desc_precision = 3;
+			drec->sql_desc_scale     = 3;
+			break;
+		case SYBMONEY:
+			drec->sql_desc_precision = 19;
+			drec->sql_desc_scale     = 4;
+			break;
+		case SYBMONEY4:
+			drec->sql_desc_precision = 10;
+			drec->sql_desc_scale     = 4;
+			break;
+		default:
+			drec->sql_desc_precision = col->column_prec;
+			drec->sql_desc_scale     = col->column_scale;
+			break;
+		}
 		/* TODO test timestamp from db, FOR BROWSE query */
 		drec->sql_desc_rowver = SQL_FALSE;
-		drec->sql_desc_scale = type == SYBDATETIME ? 3 : ((type == SYBMONEY || type == SYBMONEY4) ? 4 : col->column_scale);
 		/* TODO seem not correct */
 		drec->sql_desc_searchable = (drec->sql_desc_unnamed == SQL_NAMED) ? SQL_PRED_SEARCHABLE : SQL_UNSEARCHABLE;
 		/* TODO perhaps TINYINY and BIT.. */
diff --git a/src/odbc/odbc_util.c b/src/odbc/odbc_util.c
index d98d30e..2f85969 100644
--- a/src/odbc/odbc_util.c
+++ b/src/odbc/odbc_util.c
@@ -41,7 +41,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc_util.c,v 1.121 2010/07/24 08:26:01 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc_util.c,v 1.122 2010/08/04 06:55:45 freddy77 Exp $");
 
 /**
  * \ingroup odbc_api
@@ -703,7 +703,7 @@ odbc_server_to_sql_type(int col_type, int col_size)
 	case SYBMONEY:
 	case SYBMONEY4:
 	case SYBMONEYN:
-		return SQL_FLOAT;
+		return SQL_DECIMAL;
 	case SYBDATETIME:
 	case SYBDATETIME4:
 	case SYBDATETIMN:
@@ -852,11 +852,17 @@ odbc_set_sql_type_info(TDSCOLUMN * col, struct _drecord *drec, SQLINTEGER odbc_v
 	switch (tds_get_conversion_type(col->column_type, col->column_size)) {
 	case XSYBCHAR:
 	case SYBCHAR:
+		if (col->column_type == XSYBNCHAR)
+			SET_INFO("nchar", "'", "'");
 		SET_INFO("char", "'", "'");
 	case XSYBVARCHAR:
 	case SYBVARCHAR:
+		if (col->column_type == SYBNVARCHAR || col->column_type == XSYBNVARCHAR)
+			SET_INFO("nvarchar", "'", "'");
 		SET_INFO("varchar", "'", "'");
 	case SYBTEXT:
+		if (col->column_type == SYBNTEXT)
+			SET_INFO("ntext", "'", "'");
 		SET_INFO("text", "'", "'");
 	case SYBBIT:
 	case SYBBITN:
@@ -913,7 +919,7 @@ odbc_set_sql_type_info(TDSCOLUMN * col, struct _drecord *drec, SQLINTEGER odbc_v
 		/* FIXME for Sybase ?? */
 		SET_INFO2("uniqueidentifier", "'", "'", 36);
 	case SYBVARIANT:
-		/* SET_INFO("sql_variant", "", ""); */
+		SET_INFO("sql_variant", "", "");
 		break;
 #endif
 	case SYBMSXML:
@@ -963,7 +969,13 @@ odbc_sql_to_displaysize(int sqltype, TDSCOLUMN *col)
 		break;
 	case SQL_DECIMAL:
 	case SQL_NUMERIC:
-		size = col->column_prec + 2;
+		/* TODO check money format returned by propretary ODBC, scale == 4 but we use 2 digits */
+		if (col->column_type == SYBMONEY || (col->column_type == SYBMONEYN && col->column_size == 8))
+			size = 21;
+		else if (col->column_type == SYBMONEY4 || (col->column_type == SYBMONEYN && col->column_size == 4))
+			size = 12;
+		else
+			size = col->column_prec + 2;
 		break;
 	case SQL_DATE:
 	case SQL_TYPE_DATE:
@@ -989,11 +1001,6 @@ odbc_sql_to_displaysize(int sqltype, TDSCOLUMN *col)
 		/* TODO check REAL/FLOAT format */
 		if (col->column_type == SYBREAL || (col->column_type == SYBFLTN && col->column_size == 4))
 			size = 14;
-		/* TODO check money format returned by propretary ODBC, scale == 4 but we use 2 digits */
-		else if (col->column_type == SYBMONEY || (col->column_type == SYBMONEYN && col->column_size == 8))
-			size = 21;
-		else if (col->column_type == SYBMONEY4 || (col->column_type == SYBMONEYN && col->column_size == 4))
-			size = 12;
 		else 
 			size = 24;	/* FIXME -- what should the correct size be? */
 		break;
diff --git a/src/odbc/unittests/describecol.c b/src/odbc/unittests/describecol.c
index 502de42..f2ad1e4 100644
--- a/src/odbc/unittests/describecol.c
+++ b/src/odbc/unittests/describecol.c
@@ -6,7 +6,7 @@
  * test what say SQLDescribeCol about precision using some type
  */
 
-static char software_version[] = "$Id: describecol.c,v 1.18 2010/07/05 09:20:33 freddy77 Exp $";
+static char software_version[] = "$Id: describecol.c,v 1.19 2010/08/04 06:55:45 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static int g_result = 0;
@@ -115,6 +115,7 @@ static const struct attribute attributes[] = {
 	ATTR(SQL_DESC_PRECISION, SMALLINT),
 	ATTR(SQL_DESC_SCALE, SMALLINT),
 	ATTR(SQL_DESC_DISPLAY_SIZE, INTEGER),
+	ATTR(SQL_DESC_TYPE_NAME, CHARP),
 	ATTR2(SQL_DESC_CONCISE_TYPE, SMALLINT, sql_types),
 	ATTR2(SQL_DESC_TYPE, SMALLINT, sql_types)
 #undef ATTR2
@@ -137,17 +138,30 @@ lookup_attr(const char *name)
 
 #define SEP " \t\n"
 
-#define ATTR_PARAMS const struct attribute *attr, int expected
-typedef int (*get_attr_t) (ATTR_PARAMS);
+#define ATTR_PARAMS const struct attribute *attr, const char *expected_value
+typedef void (*check_attr_t) (ATTR_PARAMS);
 
-static int
-get_attr_ird(ATTR_PARAMS)
+static void
+check_attr_ird(ATTR_PARAMS)
 {
 	SQLLEN i;
 	SQLRETURN ret;
 
-	if (attr->type == type_CHARP)
-		fatal("Line %u: CHAR* check still not supported\n", line_num);
+	if (attr->type == type_CHARP) {
+		char buf[128];
+		SQLSMALLINT len;
+
+		ret = SQLColAttribute(odbc_stmt, 1, attr->value, buf, sizeof(buf), &len, NULL);
+		if (!SQL_SUCCEEDED(ret))
+			fatal("Line %u: failure not expected\n", line_num);
+		buf[sizeof(buf)-1] = 0;
+		if (strcmp(buf, expected_value) != 0) {
+			g_result = 1;
+			fprintf(stderr, "Line %u: invalid %s got %s expected %s\n", line_num, attr->name, buf, expected_value);
+		}
+		return;
+	}
+
 	i = 0xdeadbeef;
 	ret = SQLColAttribute(odbc_stmt, 1, attr->value, NULL, SQL_IS_INTEGER, NULL, &i);
 	if (!SQL_SUCCEEDED(ret))
@@ -160,17 +174,21 @@ get_attr_ird(ATTR_PARAMS)
 		if (i != li)
 			fatal("Line %u: attr %s SQLDescribeCol len %ld != SQLColAttribute len %ld\n", line_num, attr->name, (long) li, (long) i);
 	}
-	return i;
+	if (i != lookup(expected_value, attr->lookup)) {
+		g_result = 1;
+		fprintf(stderr, "Line %u: invalid %s got %ld expected %s\n", line_num, attr->name, (long int) i, expected_value);
+	}
 }
 
-static int
-get_attr_ard(ATTR_PARAMS)
+static void
+check_attr_ard(ATTR_PARAMS)
 {
 	SQLINTEGER i, ind;
 	SQLSMALLINT si;
 	SQLLEN li;
 	SQLRETURN ret;
 	SQLHDESC desc = SQL_NULL_HDESC;
+	char buf[128];
 
 	/* get ARD */
 	SQLGetStmtAttr(odbc_stmt, SQL_ATTR_APP_ROW_DESC, &desc, sizeof(desc), &ind);
@@ -192,19 +210,27 @@ get_attr_ard(ATTR_PARAMS)
 		i = li;
 		break;
 	case type_CHARP:
-		fatal("Line %u: CHAR* check still not supported\n", line_num);
-		break;
+		ret = SQLGetDescField(desc, 1, attr->value, buf, sizeof(buf), &ind);
+		if (!SQL_SUCCEEDED(ret))
+			fatal("Line %u: failure not expected\n", line_num);
+		if (strcmp(buf, expected_value) != 0) {
+			g_result = 1;
+			fprintf(stderr, "Line %u: invalid %s got %s expected %s\n", line_num, attr->name, buf, expected_value);
+		}
+		return;
 	}
 	if (!SQL_SUCCEEDED(ret))
 		fatal("Line %u: failure not expected\n", line_num);
-	return i;
+	if (i != lookup(expected_value, attr->lookup)) {
+		g_result = 1;
+		fprintf(stderr, "Line %u: invalid %s got %ld expected %s\n", line_num, attr->name, (long int) i, expected_value);
+	}
 }
 
 /* do not retry any attribute just return expected value so to make caller happy */
-static int
-get_attr_none(ATTR_PARAMS)
+static void
+check_attr_none(ATTR_PARAMS)
 {
-	return expected;
 }
 
 int
@@ -216,7 +242,7 @@ main(int argc, char *argv[])
 	char buf[256];
 	SQLINTEGER i;
 	SQLLEN len;
-	get_attr_t get_attr_p = get_attr_none;
+	check_attr_t check_attr_p = check_attr_none;
 
 	odbc_connect();
 	odbc_command("SET TEXTSIZE 4096");
@@ -269,7 +295,7 @@ main(int argc, char *argv[])
 			sprintf(sql, "SELECT CONVERT(%s, %s) AS col", type, value);
 
 			/* ignore error, we only need precision of known types */
-			get_attr_p = get_attr_none;
+			check_attr_p = check_attr_none;
 			if (odbc_command_with_result(odbc_stmt, sql) != SQL_SUCCESS) {
 				odbc_reset_statement();
 				SQLBindCol(odbc_stmt, 1, SQL_C_SLONG, &i, sizeof(i), &len);
@@ -278,7 +304,7 @@ main(int argc, char *argv[])
 
 			CHKFetch("SI");
 			SQLBindCol(odbc_stmt, 1, SQL_C_SLONG, &i, sizeof(i), &len);
-			get_attr_p = get_attr_ird;
+			check_attr_p = check_attr_ird;
 		}
 
 		/* set attribute */
@@ -315,23 +341,18 @@ main(int argc, char *argv[])
 			}
 			if (!SQL_SUCCEEDED(ret))
 				fatal("Line %u: failure not expected setting ARD attribute\n", line_num);
-			get_attr_p = get_attr_ard;
+			check_attr_p = check_attr_ard;
 		}
 
 		/* test attribute */
 		if (strcmp(cmd, "attr") == 0) {
 			const struct attribute *attr = lookup_attr(strtok(NULL, SEP));
-			char *value = strtok(NULL, SEP);
-			int i, expected = lookup(value, attr->lookup);
+			char *expected = strtok(NULL, SEP);
 
-			if (!value)
+			if (!expected)
 				fatal("Line %u: value not defined\n", line_num);
 
-			i = get_attr_p(attr, expected);
-			if (i != expected) {
-				g_result = 1;
-				fprintf(stderr, "Line %u: invalid %s got %d expected %d\n", line_num, attr->name, i, expected);
-			}
+			check_attr_p(attr, expected);
 		}
 	}
 
diff --git a/src/odbc/unittests/describecol.in b/src/odbc/unittests/describecol.in
index f8217c1..cf941ee 100644
--- a/src/odbc/unittests/describecol.in
+++ b/src/odbc/unittests/describecol.in
@@ -9,6 +9,7 @@ attr SQL_DESC_OCTET_LENGTH 1
 attr SQL_DESC_PRECISION 1
 attr SQL_DESC_SCALE 0
 attr SQL_DESC_DISPLAY_SIZE 1
+attr SQL_DESC_TYPE_NAME bit
 
 select tinyint 0
 attr SQL_COLUMN_LENGTH 1
@@ -79,6 +80,7 @@ attr SQL_DESC_OCTET_LENGTH 12
 attr SQL_DESC_PRECISION 10
 attr SQL_DESC_SCALE 4
 attr SQL_DESC_DISPLAY_SIZE 12
+attr SQL_DESC_CONCISE_TYPE SQL_DECIMAL
 
 select money 0
 attr SQL_COLUMN_LENGTH 21
@@ -89,6 +91,7 @@ attr SQL_DESC_OCTET_LENGTH 21
 attr SQL_DESC_PRECISION 19
 attr SQL_DESC_SCALE 4
 attr SQL_DESC_DISPLAY_SIZE 21
+attr SQL_DESC_CONCISE_TYPE SQL_DECIMAL
 
 select numeric(10,2) 0
 attr SQL_COLUMN_LENGTH 12
@@ -161,6 +164,7 @@ attr SQL_DESC_OCTET_LENGTH 24
 attr SQL_DESC_PRECISION 12
 attr SQL_DESC_SCALE 0
 attr SQL_DESC_DISPLAY_SIZE 12
+attr SQL_DESC_TYPE_NAME nchar
 
 select nvarchar(13) 'hi!'+nchar(10)
 attr SQL_COLUMN_LENGTH 26
@@ -171,6 +175,7 @@ attr SQL_DESC_OCTET_LENGTH 26
 attr SQL_DESC_PRECISION 13
 attr SQL_DESC_SCALE 0
 attr SQL_DESC_DISPLAY_SIZE 13
+attr SQL_DESC_TYPE_NAME nvarchar
 
 select text 'hi!'
 attr SQL_COLUMN_LENGTH 4096
@@ -191,6 +196,7 @@ attr SQL_DESC_OCTET_LENGTH 4096
 attr SQL_DESC_PRECISION 2048
 attr SQL_DESC_SCALE 0
 attr SQL_DESC_DISPLAY_SIZE 2048
+attr SQL_DESC_TYPE_NAME ntext
 
 select binary(10) 'hi!'
 attr SQL_COLUMN_LENGTH 10
@@ -305,6 +311,7 @@ attr SQL_DESC_OCTET_LENGTH 12
 attr SQL_DESC_PRECISION 10
 attr SQL_DESC_SCALE 4
 attr SQL_DESC_DISPLAY_SIZE 12
+attr SQL_DESC_CONCISE_TYPE SQL_DECIMAL
 
 select money 0
 attr SQL_COLUMN_LENGTH 21
@@ -315,6 +322,7 @@ attr SQL_DESC_OCTET_LENGTH 21
 attr SQL_DESC_PRECISION 19
 attr SQL_DESC_SCALE 4
 attr SQL_DESC_DISPLAY_SIZE 21
+attr SQL_DESC_CONCISE_TYPE SQL_DECIMAL
 
 select numeric(10,2) 0
 attr SQL_COLUMN_LENGTH 12
@@ -387,6 +395,7 @@ attr SQL_DESC_OCTET_LENGTH 24
 attr SQL_DESC_PRECISION 12
 attr SQL_DESC_SCALE 0
 attr SQL_DESC_DISPLAY_SIZE 12
+attr SQL_DESC_TYPE_NAME nchar
 
 select nvarchar(13) 'hi!'+nchar(10)
 attr SQL_COLUMN_LENGTH 26
@@ -397,6 +406,7 @@ attr SQL_DESC_OCTET_LENGTH 26
 attr SQL_DESC_PRECISION 13
 attr SQL_DESC_SCALE 0
 attr SQL_DESC_DISPLAY_SIZE 13
+attr SQL_DESC_TYPE_NAME nvarchar
 
 select text 'hi!'
 attr SQL_COLUMN_LENGTH 4096
@@ -417,6 +427,7 @@ attr SQL_DESC_OCTET_LENGTH 4096
 attr SQL_DESC_PRECISION 2048
 attr SQL_DESC_SCALE 0
 attr SQL_DESC_DISPLAY_SIZE 2048
+attr SQL_DESC_TYPE_NAME ntext
 
 select binary(10) 'hi!'
 attr SQL_COLUMN_LENGTH 10
@@ -457,6 +468,31 @@ attr SQL_DESC_OCTET_LENGTH 16
 attr SQL_DESC_PRECISION 36
 attr SQL_DESC_SCALE 0
 attr SQL_DESC_DISPLAY_SIZE 36
+attr SQL_DESC_TYPE_NAME uniqueidentifier
+
+select sql_variant 'hello'
+#attr SQL_COLUMN_LENGTH 0
+#attr SQL_COLUMN_PRECISION 8000
+attr SQL_COLUMN_SCALE 0
+#attr SQL_DESC_LENGTH 8000
+#attr SQL_DESC_OCTET_LENGTH 0
+#attr SQL_DESC_PRECISION 8000
+attr SQL_DESC_SCALE 0
+#attr SQL_DESC_DISPLAY_SIZE 8000
+attr SQL_DESC_TYPE_NAME sql_variant
+
+select int 654
+
+select sql_variant 123
+#attr SQL_COLUMN_LENGTH 0
+#attr SQL_COLUMN_PRECISION 8000
+attr SQL_COLUMN_SCALE 0
+#attr SQL_DESC_LENGTH 8000
+#attr SQL_DESC_OCTET_LENGTH 0
+#attr SQL_DESC_PRECISION 8000
+attr SQL_DESC_SCALE 0
+#attr SQL_DESC_DISPLAY_SIZE 8000
+attr SQL_DESC_TYPE_NAME sql_variant
 
 
 

